// $Id$
/**
* Copyright (C) 2014 EDIT
* European Distributed Institute of Taxonomy
* http://www.e-taxonomy.eu
*
* The contents of this file are subject to the Mozilla Public License Version 1.1
* See LICENSE.TXT at the top of this package for the full license terms.
*/
package eu.etaxonomy.taxeditor.httpinvoker;

import java.io.File;
import java.io.IOException;
import java.net.URISyntaxException;
import java.net.URL;

import org.apache.log4j.Logger;
import org.eclipse.core.runtime.FileLocator;
import org.eclipse.core.runtime.Platform;
import org.junit.Assert;
import org.junit.Ignore;
import org.junit.Test;
import org.osgi.framework.Bundle;

import eu.etaxonomy.taxeditor.remoting.server.CDMServerUtils;
import eu.etaxonomy.taxeditor.webapp.CDMEmbeddedServerException;
import eu.etaxonomy.taxeditor.webapp.CDMServer;
import eu.etaxonomy.taxeditor.webapp.ICDMServerError;


/**
 * @author cmathew
 * @date 6 Oct 2014
 *
 */
public class CdmServerTest extends TestConfig {
    private static final Logger logger = Logger.getLogger(CdmServerTest.class);



    @Test
    public void generateConfigFile() throws IOException {
        String mgdServerConfigFileName = "test.mgd.datasources.xml";
        String config = CDMServerUtils.convertEditorToServerConfig();
        CDMServerUtils.writeManagedServerConfig(config, mgdServerConfigFileName);
    }

    @Test
    @Ignore
    //FIXME: remove @ignore and fix test
    public void manageCdmServer() throws IOException, URISyntaxException, CDMEmbeddedServerException {
        Bundle bundle = Platform.getBundle("eu.etaxonomy.taxeditor.test");
        URL mgdDatasourcesConfigURL = bundle.getEntry("src/test/resources/.cdmLibrary/writableResources/mgd.datasources.xml");
        File mgdDatasourcesConfigFile = new File(FileLocator.resolve(mgdDatasourcesConfigURL).toURI());
        CDMServer cdmServer = new CDMServer("cdmTest", mgdDatasourcesConfigFile);
        cdmServer.start(new ICDMServerError() {
            @Override
            public void handleError(Throwable t) {
                Assert.fail("Error starting server. Reason : " + t.getMessage());
            }
        });
        try {
            cdmServer.stop();
        } catch (Exception e) {
            e.printStackTrace();
            Assert.fail("Error stopping server. Reason : " + e.getMessage());
        }
    }
}
