// $Id$
/**
 * Copyright (C) 2015 EDIT
 * European Distributed Institute of Taxonomy
 * http://www.e-taxonomy.eu
 *
 * The contents of this file are subject to the Mozilla Public License Version 1.1
 * See LICENSE.TXT at the top of this package for the full license terms.
 */
package eu.etaxonomy.taxeditor.httpinvoker;

/**
 * @author cmathew
 * @date 16 Oct 2015
 *
 */
public abstract class TestThread extends Thread {
    Throwable throwable;
    boolean isBlocked = false;

    public TestThread() {

    }

    public TestThread(boolean blocking) {
        isBlocked = blocking;
    }
    /**
     * @return the throwable
     */
    public Throwable getThrowable() {
        return throwable;
    }

    /**
     * @param throwable the throwable to set
     */
    public void setThrowable(Throwable throwable) {
        this.throwable = throwable;
    }

    public void unblock() {
        isBlocked = false;
    }

    @Override
    public final void run() {
        try {
            while(isBlocked) {};
            doRun();
        } catch(Exception ex) {
            throwable = ex;
        } catch(AssertionError ae) {
            throwable = ae;
        }
    }

    public abstract void doRun() throws Exception, AssertionError;

}
