// $Id$
/**
* Copyright (C) 2015 EDIT
* European Distributed Institute of Taxonomy
* http://www.e-taxonomy.eu
*
* The contents of this file are subject to the Mozilla Public License Version 1.1
* See LICENSE.TXT at the top of this package for the full license terms.
*/
package eu.etaxonomy.taxeditor.httpinvoker;

import java.util.HashSet;
import java.util.Set;

import org.junit.After;

/**
 * @author cmathew
 * @date 16 Oct 2015
 *
 */
public abstract class ThreadedTest  extends TestConfig {

    private Set<TestThread> threadPool = new HashSet<TestThread>();

    protected void invokeThread(TestThread thread) {
        threadPool.add(thread);
        thread.start();
    }

    @After
    public void cleanup() throws Throwable {
        try {
            for(TestThread thread : threadPool) {
                if(thread.isAlive()) {
                    thread.join();
                }
            }

            for(TestThread thread : threadPool) {
                if(thread.getThrowable() != null) {
                    throw thread.getThrowable();
                }
            }
        } finally {
            threadPool.clear();
        }
    }
}
