package eu.etaxonomy.taxeditor.lazyloading;

import org.apache.log4j.Logger;
import org.junit.Assert;
import org.junit.Test;

import eu.etaxonomy.cdm.api.application.CdmApplicationState;
import eu.etaxonomy.cdm.api.cache.CdmServiceCacher;
import eu.etaxonomy.cdm.model.common.Language;
import eu.etaxonomy.taxeditor.httpinvoker.RemotingSessionAwareTest;


public class CdmServiceCacherTest extends RemotingSessionAwareTest {
	private static final Logger logger = Logger.getLogger(CdmServiceCacherTest.class);


	private static CdmServiceCacher cdmServiceCacher = CdmApplicationState.getCdmServiceCacher();

	@Test
	public void testLanguageCache() {
		Language defaultLanguage = Language.getDefaultLanguage();

		Language defaultLanguageInCache = (Language)cdmServiceCacher.getFromCache(defaultLanguage.getUuid());
		Assert.assertEquals("Loaded Language Term should match Language Term in Cache",defaultLanguage,defaultLanguageInCache);

		Language language = Language.getLanguageFromUuid(Language.uuidFrench);
		Language languageInCache = (Language)cdmServiceCacher.getFromCache(language.getUuid());
		Assert.assertEquals("Loaded Language Term should match Language Term in Cache",language,languageInCache);

	}

}
