// $Id$
/**
* Copyright (C) 2015 EDIT
* European Distributed Institute of Taxonomy
* http://www.e-taxonomy.eu
*
* The contents of this file are subject to the Mozilla Public License Version 1.1
* See LICENSE.TXT at the top of this package for the full license terms.
*/
package eu.etaxonomy.taxeditor.lazyloading;

import java.util.Arrays;
import java.util.List;
import java.util.Set;
import java.util.UUID;

import org.junit.Ignore;
import org.junit.Test;

import eu.etaxonomy.cdm.api.service.ITaxonService;
import eu.etaxonomy.cdm.model.common.CdmBase;
import eu.etaxonomy.cdm.model.name.TaxonNameBase;
import eu.etaxonomy.cdm.model.taxon.Synonym;
import eu.etaxonomy.cdm.model.taxon.Taxon;
import eu.etaxonomy.cdm.model.taxon.TaxonBase;
import eu.etaxonomy.cdm.model.taxon.TaxonRelationship;
import eu.etaxonomy.taxeditor.httpinvoker.BaseRemotingTest;
import eu.etaxonomy.taxeditor.store.CdmStore;

/**
 * This test class is primarily for performance testing.
 * It should be used to make read-only calls to the target cdm-server.
 *
 * @author cmathew
 * @date 26 Aug 2015
 *
 */
//FIXME:Remoting ignoring until we can target integration servers
@Ignore
public class PropertyPathsTest extends BaseRemotingTest {

    @Test
    public void taxonLoadTest() {
        // load taxon Crepis from cichorieae
        UUID taxonBaseUuid = UUID.fromString("d0ae2121-1c32-4737-8c49-f871d429fd90");
        List<String> taxonBasePropertyPaths = Arrays.asList(new String[] {
                "synonymRelations.synonym.name.status.type",
                "name.homotypicalGroup.typifiedNames.taxonBases.synonymRelations.relatedFrom.name.status"
        });
        TaxonBase taxonBase = CdmStore.getService(ITaxonService.class).load(taxonBaseUuid, taxonBasePropertyPaths);
        Taxon taxon = CdmBase.deproxy(taxonBase, Taxon.class);
        Set<TaxonRelationship> taxonRelations = taxon.getTaxonRelations();
        for(TaxonRelationship rel : taxonRelations) {
            rel.getFromTaxon().getName().getStatus().size();
        }
        Set<TaxonNameBase> typifiedNames = taxon.getName().getHomotypicalGroup().getTypifiedNames();
        for(TaxonNameBase name : typifiedNames) {
            Set<TaxonBase> taxonBases = name.getTaxonBases();
            for(TaxonBase tb : taxonBases) {
            	//TODO needs to be adapted after synonym relationship removal
//                if(tb instanceof Synonym) {
//                    Synonym syn = CdmBase.deproxy(tb, Synonym.class);
//                    Set<TaxonRelationship> rels = syn.getTaxonRelations();
//                    for(TaxonRelationship rel : rels) {
//                        rel.getSynonym().getName().getStatus().size();
//                    }
//                }
                if(tb instanceof Taxon) {
                    Taxon tax = CdmBase.deproxy(tb, Taxon.class);
                    Set<TaxonRelationship> rels = tax.getTaxonRelations();
                    for(TaxonRelationship rel : rels) {
                        rel.getFromTaxon().getName().getStatus().size();
                    }
                }
            }
        }
    }

}
