package eu.etaxonomy.taxeditor.service;

import java.util.List;
import java.util.UUID;

import org.apache.log4j.Logger;
import org.junit.Assert;
import org.junit.Test;

import eu.etaxonomy.cdm.api.application.CdmApplicationState;
import eu.etaxonomy.cdm.api.cache.CdmServiceCacher;
import eu.etaxonomy.cdm.api.service.ITermService;
import eu.etaxonomy.cdm.model.common.DefinedTermBase;
import eu.etaxonomy.cdm.model.common.Language;
import eu.etaxonomy.cdm.model.common.TermType;
import eu.etaxonomy.taxeditor.httpinvoker.RemotingSessionAwareTest;

public class ServiceInterceptorTest extends RemotingSessionAwareTest {

	 private static final Logger logger = Logger.getLogger(ServiceInterceptorTest.class);
	 private final ITermService termService = getRemoteApplicationController().getTermService();
	 private static CdmServiceCacher cdmServiceCacher = CdmApplicationState.getCdmServiceCacher();


	    @Test
	    public void termServiceInterceptorTest() {
	    	List<DefinedTermBase<?>> terms = termService.listByTermType(TermType.Language, null, null, null, null);
	    	int cacheLanguageSize = 0;
	    	List<UUID> keys = cdmServiceCacher.getDefaultCache().getKeys();
	    	for(UUID key : keys) {
	    	    if(cdmServiceCacher.getFromCache(key).getClass().equals(Language.class)) {
	    	        cacheLanguageSize++;
	    	    }
	    	}
	    	Assert.assertEquals(terms.size(), cacheLanguageSize);
	    	// TO DO : get the static termTypeMap from TermServiceRequestExecutor and check the size
	    }
}
